Bug 1798797 - Review Request: ocaml-ppx-tools - Tools for authors of ppx rewriters
Summary: Review Request: ocaml-ppx-tools - Tools for authors of ppx rewriters
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Ankur Sinha (FranciscoD)
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1798798
TreeView+ depends on / blocked
 
Reported: 2020-02-06 03:08 UTC by Jerry James
Modified: 2020-02-12 16:33 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-02-12 16:33:17 UTC
Type: ---
sanjay.ankur: fedora-review+


Attachments (Terms of Use)

Description Jerry James 2020-02-06 03:08:43 UTC
Spec URL: https://jjames.fedorapeople.org/ocaml-ppx-tools/ocaml-ppx-tools.spec
SRPM URL: https://jjames.fedorapeople.org/ocaml-ppx-tools/ocaml-ppx-tools-5.3-1.fc32.src.rpm
RPMLINTRC URL: https://jjames.fedorapeople.org/ocaml-ppx-tools/ocaml-ppx-tools.rpmlintrc
Fedora Account System Username: jjames
Description: Tools for authors of syntactic tools (such as ppx rewriters).

Comment 1 Ankur Sinha (FranciscoD) 2020-02-10 23:03:43 UTC
I'll review this one.

Comment 2 Ankur Sinha (FranciscoD) 2020-02-11 11:39:38 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======

Looks good.  XXX APPROVED XXX

I have a few nitpicks where the spec doesn't match the example spec in the
guidelines (which doesn't look to up to date). Please do just check on them
before importing:
https://docs.fedoraproject.org/en-US/packaging-guidelines/OCaml/

- Should it be BR: ocaml-findlib-devel (even though it builds fine, so probably
  not)?

- Are the _use_internal_dependency_generator etc. bits mentioned in the example
  spec not needed?

- I can't find much information about the cmxs file, so I don't know if it
  should be included or not.

- The build.log file shows some warnings/errors related to debuginfo
  generation. They may not be related to the package:

Exception caught while booting Guile.
/usr/bin/gdb.minimal: warning: Could not complete Guile gdb module initialization from:
/usr/share/gdb/guile/gdb/boot.scm.
Limited Guile support is available.
Suggest passing --data-directory=/path/to/gdb/data-directory.
Error in function "open-file":
No such file or directory: "/usr/share/gdb/guile/gdb/boot.scm"Exception caught while booting Guile.
/usr/bin/gdb.minimal: warning: Could not complete Guile gdb module initialization from:
/usr/share/gdb/guile/gdb/boot.scm.
Limited Guile support is available.
Suggest passing --data-directory=/path/to/gdb/data-directory.
Exception caught while booting Guile.
/usr/bin/gdb.minimal: warning: Could not complete Guile gdb module initialization from:
/usr/share/gdb/guile/gdb/boot.scm.
Limited Guile support is available.
Suggest passing --data-directory=/path/to/gdb/data-directory.
Exception caught while booting Guile.
/usr/bin/gdb.minimal: warning: Could not complete Guile gdb module initialization from:
/usr/share/gdb/guile/gdb/boot.scm.
Limited Guile support is available.
Suggest passing --data-directory=/path/to/gdb/data-directory.
Exception caught while booting Guile.
/usr/bin/gdb.minimal: warning: Could not complete Guile gdb module initialization from:
/usr/share/gdb/guile/gdb/boot.scm.
Limited Guile support is available.
Suggest passing --data-directory=/path/to/gdb/data-directory.
Error in function "open-file":
No such file or directory: "/usr/share/gdb/guile/gdb/boot.scm"Error in function "open-file":
No such file or directory: "/usr/share/gdb/guile/gdb/boot.scm"Error in function "open-file":
No such file or directory: "/usr/share/gdb/guile/gdb/boot.scm"Error in function "open-file":
No such file or directory: "/usr/share/gdb/guile/gdb/boot.scm"original debug info size: 7760kB, size after compression: 7764kB
/usr/lib/rpm/sepdebugcrcfix: Updated 5 CRC32s, 0 CRC32s did match.
cpio: bytes.ml: Cannot stat: No such file or directory
cpio: hashtbl.ml: Cannot stat: No such file or directory
cpio: list.ml: Cannot stat: No such file or directory
cpio: parsing/ast_helper.ml: Cannot stat: No such file or directory
cpio: parsing/ast_mapper.ml: Cannot stat: No such file or directory
cpio: parsing/location.ml: Cannot stat: No such file or directory
cpio: parsing/longident.ml: Cannot stat: No such file or directory
cpio: parsing/parse.ml: Cannot stat: No such file or directory
cpio: parsing/pprintast.ml: Cannot stat: No such file or directory
cpio: printexc.ml: Cannot stat: No such file or directory
cpio: printf.ml: Cannot stat: No such file or directory
cpio: utils/load_path.ml: Cannot stat: No such file or directory
262 blocks


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[-]: %build honors applicable compiler flags or justifies otherwise.
^
I don't see anything in the Ocaml packaging guidelines about build flags.

[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[-]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[-]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[?]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 153600 bytes in 23 files.
^
I leave this for you to decide.

[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ocaml:
[x]: This should never happen

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
^
Noted that parallel make does not work reliably, so this is OK.

[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
^
I've not tested this, please do so. It installs fine.

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
^
No tests in sources.

[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ocaml-ppx-tools-5.3-1.fc32.x86_64.rpm
          ocaml-ppx-tools-devel-5.3-1.fc32.x86_64.rpm
          ocaml-ppx-tools-debuginfo-5.3-1.fc32.x86_64.rpm
          ocaml-ppx-tools-debugsource-5.3-1.fc32.x86_64.rpm
          ocaml-ppx-tools-5.3-1.fc32.src.rpm
ocaml-ppx-tools.x86_64: W: spelling-error Summary(en_US) rewriters -> rewrites, rewrite's, re writers
ocaml-ppx-tools.x86_64: W: spelling-error %description -l en_US rewriters -> rewrites, rewrite's, re writers
ocaml-ppx-tools.src: W: spelling-error Summary(en_US) rewriters -> rewrites, rewrite's, re writers
ocaml-ppx-tools.src: W: spelling-error %description -l en_US rewriters -> rewrites, rewrite's, re writers
5 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (debuginfo)
-------------------
Checking: ocaml-ppx-tools-debuginfo-5.3-1.fc32.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_GB.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_GB.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
ocaml-ppx-tools-debugsource.x86_64: W: invalid-url URL: https://github.com/ocaml-ppx/ppx_tools <urlopen error [Errno -2] Name or service not known>
ocaml-ppx-tools-devel.x86_64: W: invalid-url URL: https://github.com/ocaml-ppx/ppx_tools <urlopen error [Errno -2] Name or service not known>
ocaml-ppx-tools.x86_64: W: spelling-error Summary(en_US) rewriters -> rewrites, rewrite's, re writers
ocaml-ppx-tools.x86_64: W: spelling-error %description -l en_US rewriters -> rewrites, rewrite's, re writers
ocaml-ppx-tools.x86_64: W: invalid-url URL: https://github.com/ocaml-ppx/ppx_tools <urlopen error [Errno -2] Name or service not known>
ocaml-ppx-tools-debuginfo.x86_64: W: invalid-url URL: https://github.com/ocaml-ppx/ppx_tools <urlopen error [Errno -2] Name or service not known>
4 packages and 0 specfiles checked; 0 errors, 6 warnings.



Source checksums
----------------
https://github.com/ocaml-ppx/ppx_tools/archive/5.3+4.08.0/ppx_tools-5.3.tar.gz :
  CHECKSUM(SHA256) this package     : 843ae4f2817269e31b62101add093f0497566a5bf74205ad24dfc0a033803645
  CHECKSUM(SHA256) upstream package : 843ae4f2817269e31b62101add093f0497566a5bf74205ad24dfc0a033803645


Requires
--------
ocaml-ppx-tools (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libm.so.6()(64bit)
    ocaml(Ast_helper)
    ocaml(Ast_mapper)
    ocaml(CamlinternalFormatBasics)
    ocaml(CamlinternalLazy)
    ocaml(CamlinternalOO)
    ocaml(Docstrings)
    ocaml(Location)
    ocaml(Longident)
    ocaml(Stdlib)
    ocaml(Stdlib__buffer)
    ocaml(Stdlib__format)
    ocaml(Stdlib__int32)
    ocaml(Stdlib__int64)
    ocaml(Stdlib__lazy)
    ocaml(Stdlib__lexing)
    ocaml(Stdlib__list)
    ocaml(Stdlib__obj)
    ocaml(Stdlib__seq)
    ocaml(Stdlib__string)
    ocaml(Stdlib__uchar)
    ocaml(Warnings)
    ocaml(runtime)
    rtld(GNU_HASH)

ocaml-ppx-tools-devel (rpmlib, GLIBC filtered):
    ocaml-ppx-tools(x86-64)

ocaml-ppx-tools-debuginfo (rpmlib, GLIBC filtered):

ocaml-ppx-tools-debugsource (rpmlib, GLIBC filtered):



Provides
--------
ocaml-ppx-tools:
    ocaml(Ast_convenience)
    ocaml(Ast_mapper_class)
    ocaml-ppx-tools
    ocaml-ppx-tools(x86-64)

ocaml-ppx-tools-devel:
    ocaml-ppx-tools-devel
    ocaml-ppx-tools-devel(x86-64)

ocaml-ppx-tools-debuginfo:
    debuginfo(build-id)
    ocaml-ppx-tools-debuginfo
    ocaml-ppx-tools-debuginfo(x86-64)

ocaml-ppx-tools-debugsource:
    ocaml-ppx-tools-debugsource
    ocaml-ppx-tools-debugsource(x86-64)



Generated by fedora-review 0.7.4 (54fa030) last change: 2019-12-07
Command line :/usr/bin/fedora-review -b 1798797
Buildroot used: fedora-rawhide-x86_64
Active plugins: C/C++, Shell-api, Generic, Ocaml
Disabled plugins: fonts, Perl, Haskell, Python, PHP, SugarActivity, Java, R
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 3 dan.cermak 2020-02-11 12:35:13 UTC
(In reply to Ankur Sinha (FranciscoD) from comment #2)
> 
> - The build.log file shows some warnings/errors related to debuginfo
>   generation. They may not be related to the package:
> 
> Exception caught while booting Guile.
> /usr/bin/gdb.minimal: warning: Could not complete Guile gdb module
> initialization from:
> /usr/share/gdb/guile/gdb/boot.scm.
> Limited Guile support is available.
> Suggest passing --data-directory=/path/to/gdb/data-directory.
> Error in function "open-file":
> No such file or directory: "/usr/share/gdb/guile/gdb/boot.scm"Exception
> caught while booting Guile.
> /usr/bin/gdb.minimal: warning: Could not complete Guile gdb module
> initialization from:
> /usr/share/gdb/guile/gdb/boot.scm.
> Limited Guile support is available.
> Suggest passing --data-directory=/path/to/gdb/data-directory.
> Exception caught while booting Guile.
> /usr/bin/gdb.minimal: warning: Could not complete Guile gdb module
> initialization from:
> /usr/share/gdb/guile/gdb/boot.scm.
> Limited Guile support is available.
> Suggest passing --data-directory=/path/to/gdb/data-directory.
> Exception caught while booting Guile.
> /usr/bin/gdb.minimal: warning: Could not complete Guile gdb module
> initialization from:
> /usr/share/gdb/guile/gdb/boot.scm.
> Limited Guile support is available.
> Suggest passing --data-directory=/path/to/gdb/data-directory.
> Exception caught while booting Guile.
> /usr/bin/gdb.minimal: warning: Could not complete Guile gdb module
> initialization from:
> /usr/share/gdb/guile/gdb/boot.scm.
> Limited Guile support is available.
> Suggest passing --data-directory=/path/to/gdb/data-directory.
> Error in function "open-file":
> No such file or directory: "/usr/share/gdb/guile/gdb/boot.scm"Error in
> function "open-file":
> No such file or directory: "/usr/share/gdb/guile/gdb/boot.scm"Error in
> function "open-file":
> No such file or directory: "/usr/share/gdb/guile/gdb/boot.scm"Error in
> function "open-file":
> No such file or directory: "/usr/share/gdb/guile/gdb/boot.scm"original debug
> info size: 7760kB, size after compression: 7764kB
> /usr/lib/rpm/sepdebugcrcfix: Updated 5 CRC32s, 0 CRC32s did match.
> cpio: bytes.ml: Cannot stat: No such file or directory
> cpio: hashtbl.ml: Cannot stat: No such file or directory
> cpio: list.ml: Cannot stat: No such file or directory
> cpio: parsing/ast_helper.ml: Cannot stat: No such file or directory
> cpio: parsing/ast_mapper.ml: Cannot stat: No such file or directory
> cpio: parsing/location.ml: Cannot stat: No such file or directory
> cpio: parsing/longident.ml: Cannot stat: No such file or directory
> cpio: parsing/parse.ml: Cannot stat: No such file or directory
> cpio: parsing/pprintast.ml: Cannot stat: No such file or directory
> cpio: printexc.ml: Cannot stat: No such file or directory
> cpio: printf.ml: Cannot stat: No such file or directory
> cpio: utils/load_path.ml: Cannot stat: No such file or directory
> 262 blocks

This is probably related to this bugd https://bugzilla.redhat.com/show_bug.cgi?id=1801144

Comment 4 Jerry James 2020-02-11 16:18:35 UTC
Thank you for the review, Ankur!

(In reply to Ankur Sinha (FranciscoD) from comment #2)
> I have a few nitpicks where the spec doesn't match the example spec in the
> guidelines (which doesn't look to up to date). Please do just check on them
> before importing:
> https://docs.fedoraproject.org/en-US/packaging-guidelines/OCaml/
> 
> - Should it be BR: ocaml-findlib-devel (even though it builds fine, so
> probably
>   not)?

No, we only need the commandline tool "ocamlfind" from the ocaml-findlib package.  We do not need to link to the actual library, which is what ocaml-findlib-devel enables.

> - Are the _use_internal_dependency_generator etc. bits mentioned in the
> example
>   spec not needed?

Good grief, those should have been removed a long time ago.  No, those should not be used anymore.

> - I can't find much information about the cmxs file, so I don't know if it
>   should be included or not.

The cmxs files are the OCaml versions of a shared library.  On architectures where OCaml is able to build them ("%ifarch %{ocaml_native_compiler}"), they should be included.

> - The build.log file shows some warnings/errors related to debuginfo
>   generation. They may not be related to the package:

Dan commented on this.  Thank you, Ankur!

Comment 5 Gwyn Ciesla 2020-02-11 16:37:53 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/ocaml-ppx-tools

Comment 6 Jerry James 2020-02-12 16:33:17 UTC
Built in Rawhide and F32.


Note You need to log in before you can comment on or make changes to this bug.